
{$APPTYPE GUI}{$MODE DELPHI}

program Demo8;

uses
  SysUtils,windows,math,gl,glu,glext,GraphOGL,GraphOGL_Ext1;

//const
 
//type
  
var 
  time:glfloat;
  timer:array[1..2]of integer;  
  MoveLight:boolean;
  VolumeOnOff:boolean = true;
  NormalDot3:GLuint;
   
//{$R *.rc}
//{$R *.res}  


procedure Mdl();
begin    
  
  Toroide(0,0,0, 4,2, 1, 16,12, 0.25); 
  
end;

 
procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Set_floo.bmp',0);
  TextureLoadID('Set_flooBump.bmp',1);
  GenTexDot3(1,2,4,'Set_flooBump.bmp',NormalDot3);
  
end;
begin 

  OpenGL_Texture();
  
  SetMultiTexture(2);  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin

  if SetglKey('R')then
  begin
    timer[1]:=timer[1]+1;
    if timer[1]=3 then MoveLight:=not(MoveLight);
	if timer[1]>=10 then timer[1]:=0;
  end else timer[1]:=0;
  
  if SetglKey('V')then
  begin
    timer[2]:=timer[2]+1;
    if timer[2]=3 then VolumeOnOff:=not(VolumeOnOff);
	if timer[2]>=10 then timer[2]:=0;
  end else timer[2]:=0;  
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-20);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(15,1,0,0);
  
  SetglMouseMove(GL_M0,2);   
     
  if MoveLight then time:=time+1.75;	   
	  
  PutglPointLight(GL_LIGHT0,10, -7*Cos(DegToRad(time))-0*Sin(DegToRad(time)),7,7*Sin(DegToRad(time))+0*Cos(DegToRad(time)), 0.1);    
   
  AutoMultiTextureON;
  
  ActiveTextureON(GL_TEXTURE1); 
  CombineTexture(GL_MODULATE,0,0,0,0,0,0);  
  TextureSelectID(0);  
  
  ActiveTextureON(GL_TEXTURE0);
  CombineTexture(GL_DOT3_RGB_ARB,0,0,0,0,0,0);  
  glBindTexture(GL_TEXTURE_2D, NormalDot3);//TextureSelectID(1);  
  
  ActiveTextureON(GL_TEXTURE2);  
  TextureSelectID(1);
  
  Toroide(0,0,0, 4,2, 1, 16,12, 0.25);    
  
  if VolumeOnOff then FX_VolumePoly(0,0,0,Mdl,1,2);  
  
  ActiveTextureOFF(GL_TEXTURE2);  
  
  ActiveTextureOFF(GL_TEXTURE1); 
  
  ActiveTextureOFF(GL_TEXTURE0);    
  
  AutoMultiTextureOFF;  
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('FX_VolumePoly + ombre - R on/off rotazione luce - V on/off volume', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
